#ifndef __coatitwo_dll__
#define __coatitwo_dll__

#ifdef _MSC_VER
#ifdef COATIPROGRAM
#define COATITWODLL_API 
#else
#ifdef COATITWODLL_EXPORTS
#define COATITWODLL_API __declspec(dllexport)
#else
#define COATITWODLL_API __declspec(dllimport)
#endif
#endif
#else
#define COATITWODLL_API 
#endif


using namespace std;

#define COATITWODLL void*

//! tries to start an HTTP server for the given host address and port. Returns the resource 
// descriptor COATITWODLL. The html-root and the cgi-bin-root must be set too.
// in case of HTTP the two pems must be set nullptr (or omitted); in case of HTTPS the 
// the path to these two files must be provided.
COATITWODLL_API COATITWODLL StartHTTPServer(const char* host_address, int host_port, 
                                            const char* html_basepath, const char* cgibinpath,
                                            const char* cacert_pem = nullptr, 
                                            const char* privkey_pem = nullptr
                                           );

//! if the server is up the used port number is returned. O otherwise. 
// struct_server is the descriptor returned from StartHTTPServer.
COATITWODLL_API int ServerPort(COATITWODLL struct_server);

//! Stops the server and releases the ressources.
// struct_server is the descriptor returned from StartHTTPServer.
COATITWODLL_API int StopHTTPserver(COATITWODLL struct_server);

#endif // __coatitwo_dll__
